%bcond_with tests

Summary:        Language for writing Python extension modules
Name:           Cython3
Version: 3.0.2
Release: 4%{?dist}
License:        ASL 2.0
URL:            http://www.cython.org
Source0:        https://github.com/cython/cython/archive/%{version}/Cython-%{version}.tar.gz
# https://raw.githubusercontent.com/cython/emacs-cython-mode/3e4790559d3168fe992cf2aa62f01423038cedb5/cython-mode.el
Source1:        cython-mode.el

BuildRequires:  gcc python3-devel python3-setuptools

%if %{with tests}
BuildRequires:  gcc-c++ python3-jedi
%endif

%description
The Cython language makes writing C extensions for the Python language as easy
as Python itself. Cython is a source code translator based on Pyrex,
but supports more cutting edge functionality and optimizations.

The Cython language is a superset of the Python language (almost all Python
code is also valid Cython code), but Cython additionally supports optional
static typing to natively call C functions, operate with C++ classes and
declare fast C types on variables and class attributes.
This allows the compiler to generate very efficient C code from Cython code.

This makes Cython the ideal language for writing glue code for external C/C++
libraries, and for fast C modules that speed up the execution of Python code

%package -n     python3-Cython3
Summary:        Language for writing Python extension modules
Provides:       Cython = %{version}-%{release}
Provides:       python-cython3 = %{version}-%{release}
Provides:       python3-cython3 = %{version}-%{release}
Provides:       python%{python3_pkgversion}-cython3 = %{version}-%{release}
Conflicts:      python-Cython < 3

%description -n python3-Cython3
The Cython language makes writing C extensions for the Python language as easy
as Python itself. Cython is a source code translator based on Pyrex,
but supports more cutting edge functionality and optimizations.


%package -n     emacs-cython3-mode
Summary:        A major mode for editing Cython source files in Emacs
BuildRequires:  emacs
Requires:       emacs(bin)
Conflicts:      emacs-cython-mode < 3
BuildArch:      noarch

%description -n emacs-cython3-mode
This package provides an Emacs major mode for editing Cython source files.

%prep
%autosetup -n cython-%{version} -p1
mv %{SOURCE1} Tools

%build
%py3_build

echo ";;
(require 'cython-mode)" > cython-mode-init.el
cp -p Tools/cython-mode.el .
%{_emacs_bytecompile} *.el


%install
%py3_install

install -Dp cython-mode.el %{buildroot}%{_emacs_sitelispdir}/cython-mode.el
install -Dp cython-mode.elc %{buildroot}%{_emacs_sitelispdir}/cython-mode.elc
install -Dp cython-mode-init.el %{buildroot}%{_emacs_sitestartdir}/cython-mode-init.el
install -Dp cython-mode-init.elc %{buildroot}%{_emacs_sitestartdir}/cython-mode-init.elc

%check
%if %{with tests}
%{python3} runtests.py -vv --no-pyregr %{?_smp_mflags}
%endif


%files -n python3-Cython3
%license LICENSE.txt
%doc *.txt Demos Doc Tools
%{_bindir}/cython
%{_bindir}/cygdb
%{_bindir}/cythonize
%{python3_sitearch}/Cython-*.egg-info/
%{python3_sitearch}/Cython/
%{python3_sitearch}/pyximport/
%pycached %{python3_sitearch}/cython.py

%files -n emacs-cython3-mode
%license LICENSE.txt
%{_emacs_sitelispdir}/cython*.el*
%{_emacs_sitestartdir}/cython*.el*


%changelog
* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.0.2-4
- Rebuilt for python 3.11

* Fri Sep 15 2023 cunshunxia <cunshunxia@tencent.com> - 3.0.2-3
- rename to Cython3.

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.0.2-2
- Rebuilt for OpenCloudOS Stream 23.09

* Mon Aug 28 2023 cunshunxia <cunshunxia@tencent.com> - 3.0.2-1
- upgrade to 3.0.2

* Fri Aug 25 2023 cunshunxia <cunshunxia@tencent.com> - 3.0.1-1
- upgrade to 3.0.1

* Tue Aug 22 2023 Miaojun Dong <zoedong@tencent.com> - 3.0.0-1
- Bump version to 3.0.0

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.29.32-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.29.32-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Sep 15 2022 Shuo Wang <abushwang@tencent.com> - 0.29.32-1
- initial build

